require 'base64'
require 'fileutils'
require_relative '../dataset_utils'
require_relative '../filelogger'

module Embulk
  module Output

    class Fifoutput < OutputPlugin
      Plugin.register_output("fif", self)

      def self.transaction(config, schema, count, &control)
	@logger = LogManager.instance()
        task = { "output_path" => config.param("output_path", :string,  :default => nil) }
	if File.directory?(task['output_path'])
	else
      	  @logger.error("Output directory not found.", print=TRUE)
	  @logger.abortExecution()
	end
        task_reports = yield(task)
        next_config_diff = {}
        return next_config_diff
      end

      def init
	@output_path = task["output_path"]
	@logger = LogManager.instance()
      end

      def close
      end

      def add(page)
	begin
          page.each do |record|
	    reference = record[0]
	    data_chunk = Base64.decode64(record[1])
	    data_set_directory = @output_path.end_with?("/") ? @output_path : @output_path + "/"
	    ref = reference.reverse.sub("/".reverse, ".".reverse).reverse.sub(record[2]+"/", "")
	    if ref.end_with?(".none")
	      ref = ref[0...-5]
	    end
	    file_path = data_set_directory + ref
	    write_mode = 'ab'
	    if record[3] == DatasetUtils::DELETE
	      File.delete(file_path) if File.exist?(file_path)
	    else
	      if record[3] == TRUE.to_s
	        write_mode = 'w'
	      end
	      dirname = File.dirname(data_set_directory + ref)
	      unless File.directory?(dirname)
	        FileUtils.mkdir_p(dirname)
	      end
	      File.open(file_path, write_mode) { |file| file.write(data_chunk) }
	    end
          end
	rescue Exception => e  
          @logger.error("An error occurred while procesing file.", print=TRUE)
          @logger.error(e.backtrace)
	  raise e
	end
      end

      def finish
      end

      def abort
      end

      def commit
        task_report = {}
        return task_report
      end

    end
  end
end
