ebulk ingest-download tool help

usage: ebulk <command> <dataset> [options...]

commands:
   pull  <dataset>       Downloads the content of the target dataset from the site into the output folder
   push  <dataset>       Ingests the content of the input folder into a target dataset on the site
   -h,   --help          Tool help
   -r,   --readme        Opens README file

argument:
   dataset     		 Mandatory. Unique reference for the target dataset
			 It must start with a letter, and only alphanumerics, dots ( . ), underscores ( _ ) and hyphens ( - ) are allowed
			 * For download, the reference must be one of the available datasets on the site
			 * For ingestion, an existing reference will append the files to the corresponding dataset
			 * A new reference will create a new dataset on the site
			 It could be a path, then the last directory will be interpreted as the reference
			 e.g. pull my_directory/sample/  -->  dataset reference will be "sample"

options:
   -d,  --directory  <path>	  Besides the dataset reference, sets the dataset directory and it links that location to the reference
   -c,  --chunk  <chunk>          Sets the chunk size (in megabytes) to split large files
   -s,  --storage  <storage>	  Uses the selected input storage from this set: [http, ftp, s3]
   -cs, --custom-storage  	  Allows user to set a new input storage.
   -a,  --advanced	  	  Allows to edit the Embulk cofiguration file of the input storage


examples:
   ebulk pull <DATASET>
      * downloads the content of target dataset

   ebulk push <DATASET>
      * ingests files into the target dataset

   ebulk pull <DATASET> -d <PATH>
      * downloads the content of target dataset in target PATH
      * future operations on PATH directory will use the DATASET reference implicitly

   ebulk push <DATASET> -c 20
      * ingests files into the <DATASET> splitting them in chunks of 20MB

   ebulk push <DATASET> -s <STORAGE>
      * ingests the content of the input storage [http, ftp, s3] into the target dataset

   ebulk push <DATASET> -s <STORAGE> --advanced
      * allows the user to edit the configuration file of the selected storage

   ebulk push <DATASET> --custom-storage 
      * user can install and configure a new input plugin storage


